#ifndef LIDS_H
#define LIDS_H

/*
 * This file include everything needed for LIDS internals.
 * The biggest part is included from in lidsif.h
 *
 */

#include <linux/kernel.h>
#include <linux/sysctl.h>
#include <linux/slab.h>
#include <linux/tty.h>

#include <linux/lidsext.h>
#include <linux/lidsif.h>

#define LIDS_VERSION	"1.1.2rc4"


/* FIXME: some more externals in kernel/signal.c and kernel/sysctl.c */

extern int lids_load;		/* 1 = load ids protection , 0 = don't load */
extern lids_flags_t lids_flags;	/* 1 = load ids protection , 0 = don't load */
extern int lids_local_on;
extern unsigned long lids_current;
extern lids_flags_t lids_flags;

int _open_namei(const char * pathname, int flag, int mode, struct nameidata *nd);
struct file *_filp_open(const char * filename, int flags, int mode);

extern int lids_proc_locks_sysctl(ctl_table *table, int write, struct file *filp, void *buffer, size_t *lenp);
extern int lids_init(void);
extern void exit_lids(struct task_struct *tsk);

extern int lids_init_task_acl(struct lids_task_acl *acl);
extern int lids_compute_acls(struct lids_task_acl *current_acl,struct lids_sys_acl *new_sys_acl,struct lids_task_acl *computed_acl);
extern void lids_get_task_acl(struct lids_task_acl *acl,struct task_struct *task);
extern void lids_set_task_acl(struct lids_task_acl *acl,struct task_struct *task);
extern int lids_task_acl_deep_copy(struct lids_task_acl *dst,struct lids_task_acl *src);
extern void lids_free_lids_task_acl(struct lids_task_acl *acl);

extern struct lids_sys_acl * lids_search_acl(unsigned long int ino,kdev_t dev,unsigned long lids_curr);
extern int lids_check_base(struct dentry *base, int flag);
extern int lids_set_flags(struct lids_sys_acl *);
extern int lids_check_hidden_inode(unsigned long int ino,kdev_t dev);
extern int lids_bind_checker(const int);
extern int lids_local_off(void);

#ifdef CONFIG_LIDS_SA_THROUGH_NET
extern int lids_klids_init(void);
extern void lids_send_message(char *msg,int len);
#endif
#ifdef CONFIG_LIDS_PORT_SCAN_DETECTOR
extern void lids_port_scanner_detector_init(void);
extern int lids_check_scan(__u32 addr,__u16 port); 
#endif

#endif /* LIDS_H */
